<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing Service Provider information.
 */
 function miniorange_sp_information($form, &$form_state) {

  global $base_url;

  $issue1 = variable_get('miniorange_saml_idp_issuerID','');
  $issuer = $issue1 !='' ? $issue1 : $base_url . '/?q=admin/config/people/miniorange_saml_idp/';

 
  $url = $base_url . '/';
  $login_url = $url . '?q=initiatelogon';
  $module_path = drupal_get_path('module', 'miniorange_saml_idp');
  
  $mo_admin_email = variable_get('miniorange_saml_idp_customer_admin_email',NULL);
  
  if(!isset($mo_admin_email)){
    $form['markup_saml_idp_regsitration_message'] = array(
	  '#markup' => '<div style="display:block;margin-top:10px;text-align: center;font-size: 15px;color:red;background-color:rgba(251, 232, 0, 0.15);'
	  . ' padding:5px;border:solid 1px rgba(255, 0, 9, 0.36);">'
	  . ' Please <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp">Register or Login with miniOrange</a>'
	  . ' to enable Drupal IDP.</div>'
	);
      return $form;
  }


     $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">',);

     $form['markup_idp_header_1'] = array(
         '#markup' => '<div class="mo_saml_table_layout container">',
     );

  $form['miniorange_saml_idp_issuerID'] = array(
    '#type' => 'textfield',
    '#title' => t('IDP Entity ID/Issuer: <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
    '#default_value' => $issuer,
    '#disabled' => TRUE,
  );



$form['miniorange_saml_idp_update'] = array(
    '#type' => 'submit',
    '#value' => t('Update'),
    '#disabled' => TRUE,
  '#submit' => array('miniorange_saml_idp_update'),
  );

  $form['header'] = array(
    '#markup' => '<center><h3>You will need the following information to'
    . ' configure your Service Provider. Copy it and keep it handy</h3></center>',
  );

  $header = array(
    'attribute' => array('data' => t('Attribute')),
    'value' => array('data' => t('Value')),
  );

  $options = array();

  $options[0] = array(
    'attribute' => t('IDP-Entity ID / Issuer'),
    'value' => $issuer,
  );

  $options[1] = array(
    'attribute' => t('SAML Login URL'),
    'value' => $login_url,
  );

  $options[2] = array(
    'attribute' => t('SAML Logout URL'),
    'value' => $url,
  );

  $options[3] = array(
    'attribute' => t('Certificate (Optional)'),
    'value' => t('<a href="' . $base_url . '/' . $module_path . '/resources/idp-signing.crt">Download</a>'),
  );

  $options[4] = array(
    'attribute' => t('Response Signed'),
    'value' => 'You can choose to sign your response in'
	. ' <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp/idp_setup">Identity Provider</a>',
  );

  $options[5] = array(
    'attribute' => t('Assertion Signed'),
    'value' => 'You can choose to sign your response in'
	. ' <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp/idp_setup">Identity Provider</a>',
  );

  $form['fieldset']['spinfo'] = array(
    '#theme' => 'table',
    '#header' => $header,
    '#rows' => $options,
  );

  $form['markup_idp_sp'] = array(
    '#markup' => '<center><h3>OR</h3></center>',
  );

  $form['markup_idp_sp_1'] = array(
    '#markup' => 'You can provide this metadata URL to your Service Provider.<br /><br />',
  );

  $form['markup_idp_sp_2'] = array(
    '#markup' => '<code style="background-color: #e0e0e0;border-radius: 4px;padding: 0.8em;font-family: monospace;"><b>'
	. '<a target="_blank" href="' . $base_url . '/?q=moidp_metadata">' . $base_url . '/?q=moidp_metadata</a></b></code>',
  );

     $form['markup_idp_attr_header_top_div_close'] = array('#markup' => '</div>',
     );

     $form['markup_idp_attr_header_top_support'] = array('#markup' => '<div class="mo_saml_table_layout_support_1">',
     );

     $form['markup_support_1'] = array(
         '#markup' => '<h3><b>Support:</b></h3><div>Need any help? Just send us a query so we can help you.<br /></div>',
     );

     $form['miniorange_saml_email_address_support'] = array(
         '#title' => 'Email Address',
         '#type' => 'textfield',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your Email'),
         '#required' => TRUE,
     );

     $form['miniorange_saml_phone_number_support'] = array(
         '#title' => 'Phone Number',
         '#type' => 'textfield',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number with country code (+1)'),
     );

     $form['miniorange_saml_support_query_support'] = array(
         '#title' => 'Query',
         '#type' => 'textarea',
         '#cols' => '10',
         '#rows' => '5',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here.'),
         '#required' => TRUE,
     );

     $form['miniorange_saml_support_submit_click'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('send_support_query'),
     );

     $form['miniorange_saml_support_note'] = array(
         '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
     );

  return $form;
 }


function miniorange_saml_idp_update($form, &$form_state)
{
    $issuer= $form['miniorange_saml_idp_issuerID'] ['#value'];
    variable_set('miniorange_saml_idp_issuerID', $issuer);
}

/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    $email = $form['miniorange_saml_email_address_support']['#value'];
    $phone = $form['miniorange_saml_phone_number_support']['#value'];
    $query = $form['miniorange_saml_support_query_support']['#value'];
    $support = new MiniOrangeSamlIdpSupport($email, $phone, $query);

    $support_response = $support->sendSupportQuery();
    if($support_response) {
        drupal_set_message(t('Your support query has been sent successfully. We will get back to you soon.'));
    }
    else {
        drupal_set_message(t('Error sending support query. Please try again.'), 'error');
    }
}